"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.newClientSuccess = exports.item = exports.collection = void 0;
function collection(user, clients) {
    return {
        _links: {
            self: { href: `/user/${user.id}/client` },
            up: { href: `/user/${user.id}`, title: user.nickname },
            item: clients.map(client => ({
                href: `/user/${user.id}/client/${client.clientId}`
            })),
            'create-form': {
                href: `/user/${user.id}/client/new`,
                title: 'Add new OAuth2 credentials',
                type: 'application/vnd.siren+json',
            },
        },
        total: clients.length,
    };
}
exports.collection = collection;
function item(client, redirectUris) {
    return {
        _links: {
            self: { href: `/user/${client.user.id}/client/${client.clientId}` },
            collection: { href: `/user/${client.user.id}/client`, title: 'List of OAuth2 clients' },
        },
        clientId: client.clientId,
        allowedGrantTypes: client.allowedGrantTypes,
        redirectUris,
    };
}
exports.item = item;
function newClientSuccess(client, redirectUris, secret) {
    return {
        _links: {
            self: { href: `/user/${client.user.id}/client/${client.clientId}` },
            collection: { href: `/user/${client.user.id}/client`, title: 'List of OAuth2 clients' },
        },
        clientId: client.clientId,
        clientSecret: secret,
        allowedGrantTypes: client.allowedGrantTypes,
        redirectUris,
    };
}
exports.newClientSuccess = newClientSuccess;
//# sourceMappingURL=hal.js.map