import { OAuth2Client } from './types';
import { Context } from '@curveball/core';
import { User } from '../user/types';
export declare function getClientByClientId(clientId: string): Promise<OAuth2Client>;
export declare function findByUser(user: User): Promise<OAuth2Client[]>;
export declare function getOAuth2ClientFromBasicAuth(ctx: Context): Promise<OAuth2Client>;
export declare function getOAuth2ClientFromBody(ctx: Context<any>): Promise<OAuth2Client>;
export declare function create(client: Omit<OAuth2Client, 'id'>, redirectUris: string[]): Promise<OAuth2Client>;
export declare function validateSecret(oauth2Client: OAuth2Client, secret: string): Promise<boolean>;
